#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';
        require "flush.pl";

        &ReadInput(*INPUT);
        &ParseData(*GLOBAL, $INPUT);
	$hostname = &IpswitchName();

        # Print out header
#        &PrintButtonBar("HEADER", "IPX SAP Table: $hostname");
        &DispHelp;

	# Print out form
	&ipxquery("s");

        # Print out trailer
	print "<hr size=4>";
#        &PrintButtonBar("TRAILER");
        &PrintToe;
####### END MAIN ########



sub PrintToe {
    &SetUpHelp;
    &PrintHeadToe("TRAILER",
                  "", 
                  "",
                  "/voy.guide/Monitor_tasks.fm.html",
                  "/cgi-bin/ipxsap.pl?IH=$nhelp",
                  "");
}

sub DispHelp {
    &SetUpHelp;
    &PrintHeadToe("NPHEADER",
                   "IPX SAP Table: $hostname",		    
		      "",
		      "/voy.guide/Monitor_tasks.fm.html",
		      "/cgi-bin/ipxsap.pl?IH=$nhelp",
		      "");
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagSapFields.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}
sub ipxquery {
    local($option) = @_;

    open (FD, "/usr/local/sbin/ipxquery -$option |");
    print "</center>\n";
    print "<pre>\n";
    while (<FD>) {
#	if(/Routing/) { s/Routing/<b>Routing/; } 
#	if(/IPX/)     { s/IPX/<b>IPX/; } 
#	if(/Expire/) { s/Expire/  Expire<\/b>/; }
	print "$_";
    }
    print "</pre>\n";
    close(FD);
}

