if (!defined &_SYS_QUEUE_H_) {
    eval 'sub _SYS_QUEUE_H_ {1;}';
    eval 'sub LIST_HEAD {
        local($name, $type) = @_;
        eval "struct name { \'struct type\' *defined &lh_first && &lh_first; }";
    }';
    eval 'sub LIST_ENTRY {
        local($type) = @_;
        eval "struct struct { \'struct type\' *defined &le_next && &le_next; struct type **defined &le_prev && &le_prev; }";
    }';
    eval 'sub LIST_INIT {
        local($head) = @_;
        eval "{ ($head)->defined &lh_first && &lh_first = defined &NULL && &NULL; }";
    }';
    eval 'sub LIST_INSERT_AFTER {
        local($listelm, $elm, $field) = @_;
        eval "{ defined &if && &if ((($elm)->$field.defined &le_next && &le_next = ($listelm)->$field.defined &le_next && &le_next) != defined &NULL && &NULL) ($listelm)->$field.defined &le_next && &le_next->$field.defined &le_prev && &le_prev = &($elm)->$field.defined &le_next && &le_next; ($listelm)->$field.defined &le_next && &le_next = ($elm); ($elm)->$field.defined &le_prev && &le_prev = &($listelm)->$field.defined &le_next && &le_next; }";
    }';
    eval 'sub LIST_INSERT_HEAD {
        local($head, $elm, $field) = @_;
        eval "{ defined &if && &if ((($elm)->$field.defined &le_next && &le_next = ($head)->defined &lh_first && &lh_first) != defined &NULL && &NULL) ($head)->defined &lh_first && &lh_first->$field.defined &le_prev && &le_prev = &($elm)->$field.defined &le_next && &le_next; ($head)->defined &lh_first && &lh_first = ($elm); ($elm)->$field.defined &le_prev && &le_prev = &($head)->defined &lh_first && &lh_first; }";
    }';
    eval 'sub LIST_REMOVE {
        local($elm, $field) = @_;
        eval "{ defined &if && &if (($elm)->$field.defined &le_next && &le_next != defined &NULL && &NULL) ($elm)->$field.defined &le_next && &le_next->$field.defined &le_prev && &le_prev = ($elm)->$field.defined &le_prev && &le_prev; *($elm)->$field.defined &le_prev && &le_prev = ($elm)->$field.defined &le_next && &le_next; }";
    }';
    eval 'sub TAILQ_HEAD {
        local($name, $type) = @_;
        eval "struct name { \'struct type\' *defined &tqh_first && &tqh_first; struct type **defined &tqh_last && &tqh_last; }";
    }';
    eval 'sub TAILQ_ENTRY {
        local($type) = @_;
        eval "struct struct { \'struct type\' *defined &tqe_next && &tqe_next; struct type **defined &tqe_prev && &tqe_prev; }";
    }';
    eval 'sub TAILQ_INIT {
        local($head) = @_;
        eval "{ ($head)->defined &tqh_first && &tqh_first = defined &NULL && &NULL; ($head)->defined &tqh_last && &tqh_last = &($head)->defined &tqh_first && &tqh_first; }";
    }';
    eval 'sub TAILQ_INSERT_HEAD {
        local($head, $elm, $field) = @_;
        eval "{ defined &if && &if ((($elm)->$field.defined &tqe_next && &tqe_next = ($head)->defined &tqh_first && &tqh_first) != defined &NULL && &NULL) ($elm)->$field.defined &tqe_next && &tqe_next->$field.defined &tqe_prev && &tqe_prev = &($elm)->$field.defined &tqe_next && &tqe_next; defined &else && &else ($head)->defined &tqh_last && &tqh_last = &($elm)->$field.defined &tqe_next && &tqe_next; ($head)->defined &tqh_first && &tqh_first = ($elm); ($elm)->$field.defined &tqe_prev && &tqe_prev = &($head)->defined &tqh_first && &tqh_first; }";
    }';
    eval 'sub TAILQ_INSERT_TAIL {
        local($head, $elm, $field) = @_;
        eval "{ ($elm)->$field.defined &tqe_next && &tqe_next = defined &NULL && &NULL; ($elm)->$field.defined &tqe_prev && &tqe_prev = ($head)->defined &tqh_last && &tqh_last; *($head)->defined &tqh_last && &tqh_last = ($elm); ($head)->defined &tqh_last && &tqh_last = &($elm)->$field.defined &tqe_next && &tqe_next; }";
    }';
    eval 'sub TAILQ_INSERT_AFTER {
        local($head, $listelm, $elm, $field) = @_;
        eval "{ defined &if && &if ((($elm)->$field.defined &tqe_next && &tqe_next = ($listelm)->$field.defined &tqe_next && &tqe_next) != defined &NULL && &NULL) ($elm)->$field.defined &tqe_next && &tqe_next->$field.defined &tqe_prev && &tqe_prev = &($elm)->$field.defined &tqe_next && &tqe_next; defined &else && &else ($head)->defined &tqh_last && &tqh_last = &($elm)->$field.defined &tqe_next && &tqe_next; ($listelm)->$field.defined &tqe_next && &tqe_next = ($elm); ($elm)->$field.defined &tqe_prev && &tqe_prev = &($listelm)->$field.defined &tqe_next && &tqe_next; }";
    }';
    eval 'sub TAILQ_REMOVE {
        local($head, $elm, $field) = @_;
        eval "{ defined &if && &if ((($elm)->$field.defined &tqe_next && &tqe_next) != defined &NULL && &NULL) ($elm)->$field.defined &tqe_next && &tqe_next->$field.defined &tqe_prev && &tqe_prev = ($elm)->$field.defined &tqe_prev && &tqe_prev; defined &else && &else ($head)->defined &tqh_last && &tqh_last = ($elm)->$field.defined &tqe_prev && &tqe_prev; *($elm)->$field.defined &tqe_prev && &tqe_prev = ($elm)->$field.defined &tqe_next && &tqe_next; }";
    }';
    eval 'sub CIRCLEQ_HEAD {
        local($name, $type) = @_;
        eval "struct name { \'struct type\' *defined &cqh_first && &cqh_first; struct type *defined &cqh_last && &cqh_last; }";
    }';
    eval 'sub CIRCLEQ_ENTRY {
        local($type) = @_;
        eval "struct struct { \'struct type\' *defined &cqe_next && &cqe_next; struct type *defined &cqe_prev && &cqe_prev; }";
    }';
    eval 'sub CIRCLEQ_INIT {
        local($head) = @_;
        eval "{ ($head)->defined &cqh_first && &cqh_first = (defined &void && &void *)($head); ($head)->defined &cqh_last && &cqh_last = (defined &void && &void *)($head); }";
    }';
    eval 'sub CIRCLEQ_INSERT_AFTER {
        local($head, $listelm, $elm, $field) = @_;
        eval "{ ($elm)->$field.defined &cqe_next && &cqe_next = ($listelm)->$field.defined &cqe_next && &cqe_next; ($elm)->$field.defined &cqe_prev && &cqe_prev = ($listelm); defined &if && &if (($listelm)->$field.defined &cqe_next && &cqe_next == (defined &void && &void *)($head)) ($head)->defined &cqh_last && &cqh_last = ($elm); defined &else && &else ($listelm)->$field.defined &cqe_next && &cqe_next->$field.defined &cqe_prev && &cqe_prev = ($elm); ($listelm)->$field.defined &cqe_next && &cqe_next = ($elm); }";
    }';
    eval 'sub CIRCLEQ_INSERT_BEFORE {
        local($head, $listelm, $elm, $field) = @_;
        eval "{ ($elm)->$field.defined &cqe_next && &cqe_next = ($listelm); ($elm)->$field.defined &cqe_prev && &cqe_prev = ($listelm)->$field.defined &cqe_prev && &cqe_prev; defined &if && &if (($listelm)->$field.defined &cqe_prev && &cqe_prev == (defined &void && &void *)($head)) ($head)->defined &cqh_first && &cqh_first = ($elm); defined &else && &else ($listelm)->$field.defined &cqe_prev && &cqe_prev->$field.defined &cqe_next && &cqe_next = ($elm); ($listelm)->$field.defined &cqe_prev && &cqe_prev = ($elm); }";
    }';
    eval 'sub CIRCLEQ_INSERT_HEAD {
        local($head, $elm, $field) = @_;
        eval "{ ($elm)->$field.defined &cqe_next && &cqe_next = ($head)->defined &cqh_first && &cqh_first; ($elm)->$field.defined &cqe_prev && &cqe_prev = (defined &void && &void *)($head); defined &if && &if (($head)->defined &cqh_last && &cqh_last == (defined &void && &void *)($head)) ($head)->defined &cqh_last && &cqh_last = ($elm); defined &else && &else ($head)->defined &cqh_first && &cqh_first->$field.defined &cqe_prev && &cqe_prev = ($elm); ($head)->defined &cqh_first && &cqh_first = ($elm); }";
    }';
    eval 'sub CIRCLEQ_INSERT_TAIL {
        local($head, $elm, $field) = @_;
        eval "{ ($elm)->$field.defined &cqe_next && &cqe_next = (defined &void && &void *)($head); ($elm)->$field.defined &cqe_prev && &cqe_prev = ($head)->defined &cqh_last && &cqh_last; defined &if && &if (($head)->defined &cqh_first && &cqh_first == (defined &void && &void *)($head)) ($head)->defined &cqh_first && &cqh_first = ($elm); defined &else && &else ($head)->defined &cqh_last && &cqh_last->$field.defined &cqe_next && &cqe_next = ($elm); ($head)->defined &cqh_last && &cqh_last = ($elm); }";
    }';
    eval 'sub CIRCLEQ_REMOVE {
        local($head, $elm, $field) = @_;
        eval "{ defined &if && &if (($elm)->$field.defined &cqe_next && &cqe_next == (defined &void && &void *)($head)) ($head)->defined &cqh_last && &cqh_last = ($elm)->$field.defined &cqe_prev && &cqe_prev; defined &else && &else ($elm)->$field.defined &cqe_next && &cqe_next->$field.defined &cqe_prev && &cqe_prev = ($elm)->$field.defined &cqe_prev && &cqe_prev; defined &if && &if (($elm)->$field.defined &cqe_prev && &cqe_prev == (defined &void && &void *)($head)) ($head)->defined &cqh_first && &cqh_first = ($elm)->$field.defined &cqe_next && &cqe_next; defined &else && &else ($elm)->$field.defined &cqe_prev && &cqe_prev->$field.defined &cqe_next && &cqe_next = ($elm)->$field.defined &cqe_next && &cqe_next; }";
    }';
}
1;
