#!/usr/bin/perl

# $Id: forward.pl,v 1.23 1997/06/02 17:50:57 frances Exp $

    push (@INC, "/usr/local/www/cgi-bin");
    require 'qos-lib.pl';

    &ReadInput(*INPUT);
    &ParseData(*GLOBAL, $INPUT);
    &set_var;
    &display_help;

    if ($action eq "Create") {
	    &disp_list;
	    &edit_params;
    }
    else  {
	    &disp_list;
	    &edit_params;
    }

    &PrintHeadToe("TRAILER", 
	"", 
	"/voy.guide/Filter_tasks.fm.html", 
	"/cgi-bin/qos.pl", 
	"/cgi-bin/forward.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");


################################################

sub display_help {
 if ($ihelp eq "on") {
    print "<img src=\"/images/config/helpbar.gif\"><br>\n";
    print "<font -= 4><br>\n";
    open(FD, "/usr/local/config/help/qos.forwardRule.html");
    while (<FD>) {
        print;
    }
    close(FD);

    print "<font += 4>\n";
    print "<img src=\"/images/config/bar.gif\"><br>";
  }
}

sub disp_list {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/forward.pl\">";
    print "<center><table>\n";
    print "<tr>\n";
    print "<td valign=middle align=right><b>Forwarding Rules: </b>\n";
    print "<td align=left>\n";
    &disp_swlist($selectswitch);
    print "</tr></table>\n";
    print "<table><tr>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Select\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Copy\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Create\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Delete\"></h5>\n";
    print "</tr>";
    print "</table><hr></center></FORM>\n";

}

sub edit_params {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/forward.pl\">";
    print "<center><table>\n";
    if ($action eq "Create" || $action eq "Copy") {
	print "<b>Forwarding Rule Name: </b><INPUT TYPE=\"text\" NAME=\"NewSwitch\" SIZE=20>\n";
    }
    else {
	print "<h3>Forwarding Rule Parameters for <i>$selectswitch</i>: </h3>\n";
    }

    print "<tr align=center>\n";
    print "<td align=right><b>Forward Option: </b>";
    print "<td align=left>";
    &disp_fwdoption($fwdoption);
    print "<td align=right><b>Encapsulation: </b>";
    print "<td align=left>";
    &disp_fplist($flowproto);
    print "</tr>\n";

    print "<tr align=center>\n";
    print "<td align=right><b>Wait Packets: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"WaitPacket\" VALUE=\"$waitpacket\" SIZE=10>\n";

    print "<td align=right><b>Refresh Timer (+20sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"RefreshTimer\" VALUE=\"$refreshtimer\" SIZE=5>\n";
    print "</tr>\n";

    print "<tr>\n";
    print "<td align=right><b>Idle Timer (+10sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"IdleTimer\" VALUE=\"$idletimer\" SIZE=3>\n";
    print "<td align=right><b>Hold Timer (+10sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"HoldTimer\" VALUE=\"$holdtimer\" SIZE=5>\n";
    print "</tr>";

    print "</table></center><br>\n";
    print "<hr>\n";
    print "<center>\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"Edit\" VALUE=\"Apply\">\n";
    print "<INPUT TYPE=\"image\" SRC=\"/images/config/applybutton.gif\" BORDER=0 >\n";
   
    print "<INPUT TYPE=\"hidden\" NAME=\"SWSelect\" VALUE=\"$selectswitch\">\n";
    print "</FORM>\n";
}


sub set_var {
    $ihelp = $GLOBAL{'IHelp'};
    if (!$ihelp) {
	$ihelp = "off";
	$nhelp = "on";
    }
    elsif ($ihelp eq "off") { $nhelp = "on"; } else { $nhelp = "off"; }

    &PrintHeadToe("HEADER", 
	"Forwarding Rule Editing", 
	"/voy.guide/Filter_tasks.fm.html", 
	"/cgi-bin/html_page?TEMPLATE=main",
	"/cgi-bin/forward.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");

    &get_data;
    &get_forwarding_rules;

    $action = $GLOBAL{'Action'};
    $edit = $GLOBAL{'Edit'};
    $proceed = $GLOBAL{'Proceed'};
    $newswitch = $GLOBAL{'NewSwitch'};
    $selectswitch = $GLOBAL{'SWSelect'};
    if ($selectswitch eq "") {
	$selectswitch = $FORWARDLIST[0];
    }

#print "action=$action. proceed=$proceed. edit=$edit.<br>\n";
#print "edit=$edit, selectswitch=$selectswitch, newswitch=$newswitch.<br>";

    if ($action eq "Create") {
	$fwdoption = "switch";
	$flowproto = "";
	$waitpacket = "";
	$idletimer = "64";
	$holdtimer = "";
	$refreshtimer = "";
    }
    elsif ($edit eq "Apply") {
	$fwdoption = $GLOBAL{'FwdOption'};
	$flowproto = $GLOBAL{'FlowProto'};
	$waitpacket = $GLOBAL{'WaitPacket'};
	$idletimer = $GLOBAL{'IdleTimer'};
	$holdtimer = $GLOBAL{'HoldTimer'};
	$refreshtimer = $GLOBAL{'RefreshTimer'};
#print "applying, getting values from passed in...<br>";
#print "fwdoption=$fwdoption, flowproto=$flowproto, waitpacket=$waitpacket, idletimer=$idletimer, holdtimer=$holdtimer, refreshtimer=$refreshtimer.<br>";
    }
    else {
	$fwdoption = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fo", 5);
	$flowproto = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fp", 5);
	$waitpacket = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:wp", 5);
	$idletimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:it", 5);
	$holdtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:ht", 5);
	$refreshtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:rt", 5);
#print "fwdoption=$fwdoption, flowproto=$flowproto, waitpacket=$waitpacket, idletimer=$idletimer, holdtimer=$holdtimer, refreshtimer=$refreshtimer.<br>";
    }
 
    #
    # if proceed is OK then we're deleting for real this time
    #
    if ($action eq "Delete") {
	&update_conf("machine:$mname:policy:swt\nmachine:$mname:policy:swt:$selectswitch\nmachine:$mname:policy:swt:$selectswitch:fp\nmachine:$mname:policy:swt:$selectswitch:fo\nmachine:$mname:policy:swt:$selectswitch:wp\nmachine:$mname:policy:swt:$selectswitch:it\nmachine:$mname:policy:swt:$selectswitch:ht\nmachine:$mname:policy:swt:$selectswitch:rt\n", 1);

	&get_data;
	&get_forwarding_rules;
	$selectswitch = $FORWARDLIST[0];
	$flowproto = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fp", 5);
	$fwdoption = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fo", 5);
	$waitpacket = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:wp", 5);
	$idletimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:it", 5);
	$holdtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:ht", 5);
	$refreshtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:rt", 5);
    }

    #
    # if edit is Apply then we're applying the changes for real this time
    #
    if ($edit ne "") {
#print "edit=$edit, newswitch=$newswitch, selectswitch=$selectswitch.<br>";
      if ($newswitch ne "") {
	$selectswitch = $newswitch;
      }

#      if ($flowproto eq "") {$flowproto = "any"};
      if ($fwdoption eq "") {$fwdoption = "switch"};
#      if ($waitpacket eq "") {$waitpacket = "any"};
      if ($idletimer eq "") {$idletimer = "64"};
#      if ($holdtimer eq "") {$holdtimer = "any"};
#      if ($refreshtimer eq "") {$refreshtimer = "any"};

      if ($edit eq "Apply") {
	&update_conf("machine:$mname:policy:swt t\n\nmachine:$mname:policy:swt:$selectswitch t\nmachine:$mname:policy:swt:$selectswitch:fp $flowproto\nmachine:$mname:policy:swt:$selectswitch:fo $fwdoption\nmachine:$mname:policy:swt:$selectswitch:wp $waitpacket\nmachine:$mname:policy:swt:$selectswitch:it $idletimer\nmachine:$mname:policy:swt:$selectswitch:ht $holdtimer\nmachine:$mname:policy:swt:$selectswitch:rt $refreshtimer\n", 1);

      }

      &get_data;
      &get_forwarding_rules;
    }
}

