if (!defined &_SYS_SIGNAL_H_) {
    eval 'sub _SYS_SIGNAL_H_ {1;}';
    eval 'sub NSIG {32;}';
    if (!defined &_ANSI_SOURCE) {
	require 'machine/signal.ph';
    }
    eval 'sub SIGHUP {1;}';
    eval 'sub SIGINT {2;}';
    eval 'sub SIGQUIT {3;}';
    eval 'sub SIGILL {4;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGTRAP {5;}';
    }
    eval 'sub SIGABRT {6;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGIOT {defined &SIGABRT && &SIGABRT;}';
	eval 'sub SIGEMT {7;}';
    }
    eval 'sub SIGFPE {8;}';
    eval 'sub SIGKILL {9;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGBUS {10;}';
    }
    eval 'sub SIGSEGV {11;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGSYS {12;}';
    }
    eval 'sub SIGPIPE {13;}';
    eval 'sub SIGALRM {14;}';
    eval 'sub SIGTERM {15;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGURG {16;}';
    }
    eval 'sub SIGSTOP {17;}';
    eval 'sub SIGTSTP {18;}';
    eval 'sub SIGCONT {19;}';
    eval 'sub SIGCHLD {20;}';
    eval 'sub SIGTTIN {21;}';
    eval 'sub SIGTTOU {22;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub SIGIO {23;}';
	eval 'sub SIGXCPU {24;}';
	eval 'sub SIGXFSZ {25;}';
	eval 'sub SIGVTALRM {26;}';
	eval 'sub SIGPROF {27;}';
	eval 'sub SIGWINCH {28;}';
	eval 'sub SIGINFO {29;}';
    }
    eval 'sub SIGUSR1 {30;}';
    eval 'sub SIGUSR2 {31;}';
    if ( defined( &_ANSI_SOURCE) || defined( &__cplusplus)) {
	eval 'sub SIG_DFL {(defined &void && &void (*))0;}';
	eval 'sub SIG_IGN {(defined &void && &void (*))1;}';
	eval 'sub SIG_ERR {(defined &void && &void (*))-1;}';
    }
    else {
	eval 'sub SIG_DFL {(defined &void && &void (*)())0;}';
	eval 'sub SIG_IGN {(defined &void && &void (*)())1;}';
	eval 'sub SIG_ERR {(defined &void && &void (*)())-1;}';
    }
    if (!defined &_ANSI_SOURCE) {
	if (!defined &_POSIX_SOURCE) {
	    eval 'sub SA_ONSTACK {0x0001;}';
	    eval 'sub SA_RESTART {0x0002;}';
	    eval 'sub SA_DISABLE {0x0004;}';
	    if (defined &COMPAT_SUNOS) {
		eval 'sub SA_USERTRAMP {0x0100;}';
	    }
	}
	eval 'sub SA_NOCLDSTOP {0x0008;}';
	eval 'sub SIG_BLOCK {1;}';
	eval 'sub SIG_UNBLOCK {2;}';
	eval 'sub SIG_SETMASK {3;}';
	if (!defined &_POSIX_SOURCE) {
	    if (!defined &KERNEL) {
		require 'sys/cdefs.ph';
	    }
	    eval 'sub MINSIGSTKSZ {8192;}';
	    eval 'sub SIGSTKSZ {(defined &MINSIGSTKSZ && &MINSIGSTKSZ + 32768);}';
	    eval 'sub SV_ONSTACK {defined &SA_ONSTACK && &SA_ONSTACK;}';
	    eval 'sub SV_INTERRUPT {defined &SA_RESTART && &SA_RESTART;}';
	    eval 'sub sv_onstack {defined &sv_flags && &sv_flags;}';
	    eval 'sub sigmask {
	        local($m) = @_;
	        eval "(1 << (($m)-1))";
	    }';
	    eval 'sub BADSIG {defined &SIG_ERR && &SIG_ERR;}';
	}
    }
}
1;
